diff --git a/src/pitransl.ml b/src/pitransl.ml
index f238b9a..158de8c 100644
--- a/src/pitransl.ml
+++ b/src/pitransl.ml
@@ -29,6 +29,8 @@ open Parsing_helper
 open Types
 open Pitypes
 
+let initial_cell_states () = List.map snd !Param.cells
+
 (* TO DO: improve this translation algorithm by
    making the unifications as soon as they are known.
    Pb: we have to be able to undo unifications... *)
@@ -94,6 +96,8 @@ let rec check_uniq_ev f = function
  | Get(_,_,p,_) -> check_uniq_ev f p
  | Phase(n,p,_) ->
      check_uniq_ev f p
+ | Lock(_,p) | Unlock(_,p)
+ | ReadAs(_,p) | Assign(_,p) -> check_uniq_ev f p
 
 (* Compute in accu the list of events that are injective, so that
    they must be executed at most once for each value of the session
@@ -120,6 +124,9 @@ let rec get_uniq_ev_proc accu = function
  | Get(_,_,p,_) -> get_uniq_ev_proc accu p
  | Phase(n,p,_) ->
      get_uniq_ev_proc accu p
+ | Lock(_,p) | Unlock(_,p)
+ | ReadAs(_,p) | Assign(_,p) ->
+     get_uniq_ev_proc accu p
 
 (* Check that all injective events can be executed at most once
    for each value of the session identifiers *)
@@ -306,6 +313,7 @@ type name_param_info =
    term: to put as parameter of name function symbol
 *)
 
+type stronger_state = PhiIsStronger | HypIsStronger
 
 type transl_state = 
     { hypothesis : fact list; (* Current hypotheses of the rule *)
@@ -328,14 +336,19 @@ type transl_state =
       cur_phase : int;
       input_pred : predicate;
       output_pred : predicate;
-      hyp_tags : hypspec list
+      hyp_tags : hypspec list;
+      stronger_state : stronger_state;
+      last_states : term list; (* last known cell states *)
+      cell_locks : bool list   (* lock status for each cell *)
     }
 
-let att_fact phase t =
-  Pred(Param.get_pred (Attacker(phase, Terms.get_term_type t)), [t])
+let att_fact phase last_states t =
+  assert ((List.length last_states) = (List.length !Param.cells));
+  Pred(Param.get_pred (Attacker(phase, Terms.get_term_type t)), last_states @ [t])
   
-let mess_fact phase tc tm =
-  Pred(Param.get_pred (Mess(phase, Terms.get_term_type tm)), [tc;tm])
+let mess_fact phase last_states tc tm =
+  assert ((List.length last_states) = (List.length !Param.cells));
+  Pred(Param.get_pred (Mess(phase, Terms.get_term_type tm)), last_states @ [tc;tm])
   
 let table_fact phase t =
   Pred(Param.get_pred (Table(phase)), [t])
@@ -399,6 +412,18 @@ let output_rule { hypothesis = prev_input; constra = constra; unif = unif;
       let constra2 = List.map Terms.copy_constra2 constra in
       let name_params2 = List.map Terms.copy_term2 name_params in
       Terms.cleanup();
+      let hyp, concl, constra2 = (
+        if !Param.propagate_state then
+          Optimisation.propagate_state hyp concl constra2
+        else
+          hyp, concl, constra2 (* do nothing *)
+        ) in
+      let hyp, hyp_tags, concl = (
+        if !Param.dejunk_hypotheses then
+          Optimisation.dejunk hyp hyp_tags concl
+        else
+          hyp, hyp_tags, concl (* do nothing *)
+        ) in
       begin
 	try
 	  add_rule hyp concl (Rules.simplify_constra_list (concl::hyp) constra2) 
@@ -706,6 +731,26 @@ let transl_fact next_fun f cur_state =
       transl_term_list_incl_destructor (fun patl cur_state1 ->
 	next_fun (Pred(p,patl)) cur_state1) tl cur_state 
 
+let rec dup_term = function
+    FunApp(f, args) -> FunApp(f, List.map dup_term args)
+  | Var x -> Var (Terms.copy_var x)
+
+let rec dup_pat = function
+    PatVar x -> PatVar (Terms.copy_var x)
+  | PatTuple(f,l) -> PatTuple(f, List.map dup_pat l)
+  | PatEqual(t) -> PatEqual(dup_term t)
+
+(* Produce fresh variables for all unlocked cells. *)
+
+let freshen_cells cur_state =
+    List.map2 (fun (old_value, locked) cell ->
+        if locked then
+            old_value
+        else
+            Var (Terms.new_var ("v" ^ (fst cell)) Param.any_type))
+        (List.combine cur_state.last_states cur_state.cell_locks)
+        !Param.cells
+
 (* Translate process *)
 
 let rec transl_process cur_state = function
@@ -733,14 +778,14 @@ let rec transl_process cur_state = function
 	 begin
 	   if (!Param.key_compromise == 0) then
 	     transl_process { cur_state with 
-			      hypothesis = (att_fact cur_state.cur_phase (Var v)) :: cur_state.hypothesis;
+			      hypothesis = (att_fact cur_state.cur_phase (freshen_cells cur_state) (Var v)) :: cur_state.hypothesis;
 			      current_session_id = Some v;
 			      name_params = Always(("!" ^ (string_of_int cur_state.repl_count)), v', Var v) :: cur_state.name_params;
 			      hyp_tags = (ReplTag(occ, count_params)) :: cur_state.hyp_tags
 			    } p
 	   else if (!Param.key_compromise == 1) then
 	     transl_process { cur_state with 
-			      hypothesis = (att_fact cur_state.cur_phase (Var v)) :: (att_fact cur_state.cur_phase (Var comp_session_var)) :: cur_state.hypothesis;
+			      hypothesis = (att_fact cur_state.cur_phase (freshen_cells cur_state) (Var v)) :: (att_fact cur_state.cur_phase (freshen_cells cur_state) (Var comp_session_var)) :: cur_state.hypothesis;
 			      current_session_id = Some v;
 			      name_params = Always("!comp", comp_session_var, Var comp_session_var) :: 
                                  Always(("!" ^ (string_of_int cur_state.repl_count)), v', Var v) :: cur_state.name_params;
@@ -748,7 +793,7 @@ let rec transl_process cur_state = function
 			    } p
 	   else 
 	     transl_process { cur_state with 
-			      hypothesis = (att_fact cur_state.cur_phase (Var v)) :: cur_state.hypothesis;
+			      hypothesis = (att_fact cur_state.cur_phase (freshen_cells cur_state) (Var v)) :: cur_state.hypothesis;
 			      current_session_id = Some v;
 			      name_params = Always("!comp", v', compromised_session) :: 
                                  Always(("!" ^ (string_of_int cur_state.repl_count)), v', Var v) :: cur_state.name_params;
@@ -831,10 +876,10 @@ let rec transl_process cur_state = function
       let v = Reduction_helper.new_var_pat pat in
       begin
         match tc with
-          FunApp({ f_cat = Name _; f_private = false },_) when !Param.active_attacker ->
+          (*FunApp({ f_cat = Name _; f_private = false },_) when !Param.active_attacker ->
 	    transl_pat PutAlways (end_destructor_group (fun cur_state1 -> transl_process cur_state1 p) occ)
 	      pat v { cur_state with 
-		      hypothesis = (att_fact cur_state.cur_phase v) :: cur_state.hypothesis;
+		      hypothesis = (att_fact cur_state.cur_phase (freshen_cells cur_state) v) :: cur_state.hypothesis;
 		      hyp_tags = (InputTag(occ)) :: cur_state.hyp_tags 
 		    };
             if !Param.non_interference then
@@ -845,13 +890,15 @@ let rec transl_process cur_state = function
 		    (Pred(cur_state.input_pred, [pat1]))
                 ) occ cur_state1
               ) tc cur_state
-        | _ -> 
+        | *)_ -> 
 	    transl_term_incl_destructor (fun pat1 cur_state1 ->
               end_destructor_group (fun cur_state2 ->
+	        let phi' = freshen_cells cur_state2 in
 	        transl_pat PutAlways (end_destructor_group (fun cur_state3 -> 
                   transl_process cur_state3 p) occ) pat v 
 		    { cur_state2 with 
-		      hypothesis = (mess_fact cur_state.cur_phase pat1 v) :: cur_state2.hypothesis;
+		      hypothesis = (mess_fact cur_state.cur_phase phi' pat1 v) :: cur_state2.hypothesis;
+		      last_states = phi';
 		      hyp_tags = (InputTag(occ)) :: cur_state2.hyp_tags
 		    };
 	        if !Param.non_interference then
@@ -863,8 +910,8 @@ let rec transl_process cur_state = function
       end
  | Output(tc,t,p,occ) ->
       begin
-        match tc with 
-          FunApp({ f_cat = Name _; f_private = false },_) when !Param.active_attacker -> 
+        match tc with
+          (*FunApp({ f_cat = Name _; f_private = false },_) when !Param.active_attacker -> 
 	    if !Param.non_interference then
 	    begin
 	      transl_term (fun cur_state1 patc ->
@@ -880,23 +927,62 @@ let rec transl_process cur_state = function
                 output_rule { cur_state2 with 
                               hypothesis = replace_begin_out cur_state2.name_params cur_state2.hyp_tags cur_state2.hypothesis;
                               hyp_tags = (OutputTag occ) :: cur_state2.hyp_tags
-			    } (att_fact cur_state.cur_phase pat1)
+			    } (att_fact cur_state.cur_phase cur_state.last_states pat1)
               ) occ cur_state1
             ) cur_state t
-        | _ -> transl_term (fun cur_state1 patc ->
+        | *)_ -> transl_term (fun cur_state1 patc ->
                  transl_term (fun cur_state2 pat1 ->
                    end_destructor_group (fun cur_state3 ->
-         	     if !Param.non_interference then
+                     if !Param.non_interference then
                        output_rule { cur_state3 with
                                      hyp_tags = (OutputPTag occ) :: cur_state3.hyp_tags }
-			  (Pred(cur_state.output_pred, [patc]));
+                          (Pred(cur_state.output_pred, [patc]));
+
+                     let state_to_use = (
+                       if (List.for_all ((=) true) cur_state.cell_locks) then
+                         cur_state.last_states
+                       else begin
+                           if !Param.output_mode <> Param.PhiOutput then
+                             try
+                               let last_hyp_state = (
+                                 match (
+                                   List.find (
+                                     function
+                                         Pred({p_info = [Attacker(_,_)]},_)
+                                       | Pred({p_info = [Mess(_,_)]},_) -> true
+                                       | _ -> false
+                                     ) cur_state.hypothesis
+                                 ) with
+                                     Pred({p_info = [Attacker(_,_)]},args) -> fst (Lists.head_tail args 1)
+                                   | Pred({p_info = [Mess(_,_)]},args) -> fst (Lists.head_tail args 2)
+                                   | _ -> raise Not_found )
+                               in
+                               if (!Param.output_mode = Param.HypothesisOutput) then
+                                 last_hyp_state
+                               else if (!Param.output_mode = Param.OldHeuristicOutput) then
+                                 if (List.for_all (function Var x -> true | _ -> false) last_hyp_state) then
+                                   last_hyp_state
+                                 else
+                                   cur_state.last_states
+                               else if (!Param.output_mode = Param.HeuristicOutput) then
+                                 match cur_state.stronger_state with
+                                   | PhiIsStronger -> cur_state.last_states
+                                   | HypIsStronger -> last_hyp_state
+                               else
+                                 raise Not_found (* Should not reach here *)
+                             with Not_found ->
+                               cur_state.last_states
+                           else
+                             cur_state.last_states
+                       end)
+                     in
                      output_rule { cur_state3 with 
-				   hypothesis = replace_begin_out cur_state3.name_params cur_state3.hyp_tags cur_state3.hypothesis;
+                                   hypothesis = replace_begin_out cur_state3.name_params cur_state3.hyp_tags cur_state3.hypothesis;
                                    hyp_tags = (OutputTag occ) :: cur_state2.hyp_tags
-			         } (mess_fact cur_state.cur_phase patc pat1)
+                                 } (mess_fact cur_state.cur_phase state_to_use patc pat1)
                    ) occ cur_state2
                  ) cur_state1 t
-	       ) cur_state tc
+               ) cur_state tc
       end;
       transl_process { cur_state with
                        hyp_tags = (OutputTag occ) :: cur_state.hyp_tags } p
@@ -1036,12 +1122,115 @@ let rec transl_process cur_state = function
                       cur_phase = n;
                       input_pred = Param.get_pred (InputP(n));
                       output_pred = Param.get_pred (OutputP(n)) } p
+ | Lock(cells, p) ->
+     let phi' = (freshen_cells cur_state) in
+     let new_locks =
+        (List.fold_left
+          (fun locks cell_name ->
+            (Lists.update_list locks (Param.find_cell_index cell_name) true))
+          cur_state.cell_locks cells) in
+     transl_process { cur_state with
+                      cell_locks = new_locks;
+                      last_states = phi' } p
+ | Unlock(cells, p) ->
+     let phi' = freshen_cells cur_state in
+     let new_locks =
+        (List.fold_left
+          (fun locks cell_name ->
+            (Lists.update_list locks (Param.find_cell_index cell_name) false))
+          cur_state.cell_locks cells) in
+     transl_process { cur_state with
+                      last_states = phi';
+                      cell_locks = new_locks } p
+ | Assign(pairs, p) ->
+     (* pats = list of patterns from transl_term, one for each item in pairs *)
+     let translate_assignment pats cur_state = begin
+        let phi' = (freshen_cells cur_state) in
+        let phi'' =
+          (List.fold_left2
+            (fun phi'' (cell, _) pat ->
+              (Lists.update_list phi'' (Param.find_cell_index cell) pat))
+            phi' pairs pats)
+        in
+        let vc = Var (Terms.new_var "vc" Param.channel_type) in
+        let vm = Var (Terms.new_var "vm" Param.any_type) in
+        let cell_indices = (List.map (fun (cell, _) -> (Param.find_cell_index cell)) pairs) in
+        output_rule { cur_state with
+                      hypothesis = replace_begin_out cur_state.name_params cur_state.hyp_tags
+                                                     ((mess_fact cur_state.cur_phase phi' vc vm) :: cur_state.hypothesis);
+                      hyp_tags = (AssignmentTag(cell_indices)) :: cur_state.hyp_tags
+                    } (mess_fact cur_state.cur_phase phi'' vc vm);
+        output_rule { cur_state with
+                      hypothesis = replace_begin_out cur_state.name_params cur_state.hyp_tags
+                                                     ((att_fact cur_state.cur_phase phi' vm) :: cur_state.hypothesis);
+                      hyp_tags = (AssignmentTag(cell_indices)) :: cur_state.hyp_tags
+                    } (att_fact cur_state.cur_phase phi'' vm);
+        transl_process { cur_state with
+                         stronger_state = PhiIsStronger;
+                         last_states = phi'' } p
+     end in
+     let rec transl_terms pats pairs' cur_state = begin
+        match pairs' with
+        | [] -> (end_destructor_group (translate_assignment (List.rev pats)) 0 cur_state)
+        | (cell, term) :: rest ->
+            (transl_term
+              (fun cur_state pat -> (transl_terms (pat :: pats) rest cur_state))
+              cur_state term)
+     end in
+     (transl_terms [] pairs cur_state)
+  | ReadAs(pairs, p) ->
+     let phi' = (freshen_cells cur_state) in
+     let vc = Var (Terms.new_var "vc" Param.channel_type) in
+     let vm = Var (Terms.new_var "vm" Param.any_type) in
+     let cell_indices = (List.map (fun (cell, _) -> (Param.find_cell_index cell)) pairs) in
+     let rec transl_patterns pairs' cur_state = begin
+        match pairs' with
+        | [] ->
+          begin
+            transl_process { cur_state with
+                             hypothesis     = (mess_fact cur_state.cur_phase phi' vc vm) :: cur_state.hypothesis;
+                             hyp_tags       = (ReadTag(cell_indices)) :: cur_state.hyp_tags;
+                             stronger_state = PhiIsStronger;
+                             last_states    = phi' } p
+          end
+        | (cell, pattern) :: rest ->
+            (transl_pat PutAlways (end_destructor_group (transl_patterns rest) 0)
+              pattern (List.nth phi' (Param.find_cell_index cell)) cur_state)
+     end in
+     (end_destructor_group (transl_patterns pairs) 0 cur_state)
+
+(* Produce a list of terms representing any state,
+   for example [Var vs1; Var vs2] in
+   attacker((vs1,vs2),vc) & attacker((vs1,vs2),vm) -> message((vs1,vs2),vc,vm) *)
+let free_cells_inner = ref None
+let free_cells () =
+    begin
+        match !free_cells_inner with
+            None ->
+                free_cells_inner := Some (
+                    List.map (fun (name, initial_value) ->
+                        Var ({
+                            sname = "freecell_" ^ name;
+                            vname = 0;
+                            btype = Param.any_type;
+                            link = NoLink
+                        }))
+                        !Param.cells)
+          | Some _ -> ()
+    end;
+    match !free_cells_inner with Some x -> x
+
+(* Similarly but produce formats. *)
+let free_cell_vars t =
+    List.map (fun (name, initial_value) ->
+        FVar(Terms.new_var ("freecell_" ^ name) t))
+        !Param.cells
 
 let rules_for_red f phase red_rule =
   let res_pred = Param.get_pred (Attacker(phase, snd f.f_type)) in
   let (hyp, concl) = Terms.copy_red red_rule in
-  add_rule (List.map (att_fact phase) hyp)
-    (att_fact phase concl) [] (Apply(Func(f), res_pred));
+  add_rule (List.map (att_fact phase (free_cells ())) hyp)
+    (att_fact phase (free_cells ()) concl) [] (Apply(Func(f), res_pred));
   if !Param.non_interference then
     begin
       if !Terms.current_bound_vars != [] then
@@ -1054,7 +1243,7 @@ let rules_for_red f phase red_rule =
       let vlist = List.map Terms.new_var_def thyp in
       add_rule 
         ((Pred(testunif_pred, [FunApp(tuple_fun, vlist); FunApp(tuple_fun, hyp')]))
-	 :: List.map (att_fact phase) vlist)
+	 :: List.map (att_fact phase (free_cells ())) vlist)
 	(Pred(bad_pred, []))
 	[]
 	(TestApply(Func(f), res_pred))
@@ -1069,24 +1258,26 @@ let rules_for_function phase _ f =
      match f.f_cat with
        Eq red_rules -> 
 	 let vars = Terms.var_gen (fst f.f_type) in
-	 add_rule (List.map (att_fact phase) vars)
-           (att_fact phase (FunApp(f,vars))) [] (Apply(Func(f), res_pred));
+	 let phi = (if (vars = []) then (initial_cell_states ()) else (free_cells())) in
+	 add_rule (List.map (att_fact phase phi) vars)
+           (att_fact phase phi (FunApp(f,vars))) [] (Apply(Func(f), res_pred));
 	 List.iter (rules_for_red f phase) red_rules
      | Red red_rules ->
 	 List.iter (rules_for_red f phase) red_rules
      | Tuple ->
 	(* For tuple constructor *)
 	 let vars = Terms.var_gen (fst f.f_type) in
-	 add_rule (List.map (att_fact phase) vars)
-	   (att_fact phase (FunApp(f, vars))) []
+	 let phi = (if (vars = []) then (initial_cell_states ()) else (free_cells ())) in
+	 add_rule (List.map (att_fact phase phi) vars)
+	   (att_fact phase phi (FunApp(f, vars))) []
 	   (Apply(Func(f), res_pred));
 
 	(* For corresponding projections *)
 	 for n = 0 to (List.length (fst f.f_type))-1 do
 	   let vars = Terms.var_gen (fst f.f_type) in
 	   let v = List.nth vars n in
-	   add_rule [att_fact phase (FunApp(f, vars))]
-	     (att_fact phase v) []
+	   add_rule [att_fact phase (free_cells ()) (FunApp(f, vars))]
+	     (att_fact phase (free_cells ()) v) []
 	     (Apply(Proj(f,n),res_pred))
 	 done
      | _ -> ()
@@ -1103,16 +1294,16 @@ let transl_attacker phase =
     (* The attacker has any message sent on a channel he has *)
     let v = Terms.new_var_def t in
     let vc = Terms.new_var_def Param.channel_type in
-    add_rule [Pred(mess_pred, [vc; v]); att_fact phase vc]
-          (Pred(att_pred, [v])) [] (Rl(att_pred,mess_pred));
+    add_rule [Pred(mess_pred, (free_cells ()) @ [vc; v]); att_fact phase (free_cells ()) vc]
+          (Pred(att_pred, (free_cells ()) @ [v])) [] (Rl(att_pred,mess_pred));
 
     if (!Param.active_attacker) then
       begin
       (* The attacker can send any message he has on any channel he has *)
 	let v = Terms.new_var_def t in
 	let vc = Terms.new_var_def Param.channel_type in
-	add_rule [att_fact phase vc; Pred(att_pred, [v])]
-          (Pred(mess_pred, [vc; v])) [] (Rs(att_pred, mess_pred))
+	add_rule [att_fact phase (free_cells ()) vc; Pred(att_pred, (free_cells ()) @ [v])]
+          (Pred(mess_pred, (free_cells ()) @ [vc; v])) [] (Rs(att_pred, mess_pred))
       end) (if !Param.ignore_types then [Param.any_type] else !Param.all_types);
 
   
@@ -1259,7 +1450,7 @@ let rec comp_transl_process = function
 	     (comp_fact (FunApp(n, name_params)));
 	   if List.exists (fun x -> x == compromised_session) name_params then
 	     comp_output_rule prev_input 
-	       (att_fact 0 (FunApp(n, name_params)))
+	       (att_fact 0 [](FunApp(n, name_params)))
        | _ -> internal_error "name expected in comp_transl_process"
      end;
      comp_transl_process p
@@ -1401,7 +1592,7 @@ let transl p =
     List.iter (fun t -> 
       let att_i = Param.get_pred (Attacker(i,t)) in
       let v = Terms.new_var Param.def_var_name t in
-      Selfun.add_no_unif (att_i, [FVar v]) Selfun.never_select_weight;
+      Selfun.add_no_unif (att_i, (free_cell_vars Param.any_type) @ [FVar v]) Selfun.never_select_weight;
       if i > 0 then
 	let w = Terms.new_var_def t in
 	let att_im1 = Param.get_pred (Attacker(i-1,t)) in
@@ -1421,7 +1612,7 @@ let transl p =
       The non-interference queries have their private flag set. *)
    List.iter (fun ch ->
       if not ch.f_private then
-        add_rule [] (att_fact 0 (FunApp(ch, []))) [] Init) (!Param.freenames);
+        add_rule [] (att_fact 0 (initial_cell_states ()) (FunApp(ch, []))) [] Init) (!Param.freenames);
 
   List.iter (fun t ->
     (* Clauses for equality *)
@@ -1434,10 +1625,10 @@ let transl p =
     let v = Terms.new_var_def Param.sid_type in
     let new_name_fun = Terms.new_name_fun t in
     if !Param.non_interference then
-      add_rule [att_fact 0 v] (att_fact 0 (FunApp(new_name_fun, [v])))
+      add_rule [att_fact 0 (initial_cell_states ()) v] (att_fact 0 (initial_cell_states ()) (FunApp(new_name_fun, [v])))
 	[] (Rn (Param.get_pred (Attacker(0, t))))
     else
-      add_rule [] (att_fact 0 (FunApp(new_name_fun, [v])))
+      add_rule [] (att_fact 0 (initial_cell_states ()) (FunApp(new_name_fun, [v])))
 	[] (Rn (Param.get_pred (Attacker(0, t))));
 
     if (!Param.non_interference) then
@@ -1471,7 +1662,7 @@ let transl p =
 	   List.map (fun t -> 
 	     let v = Terms.new_var_def t in
 	     let att_guess = Param.get_pred (AttackerGuess(t)) in
-	     let hyp = [att_fact (!Param.max_used_phase) v] in
+	     let hyp = [att_fact (!Param.max_used_phase) [] v] in
 	     let concl = Pred(att_guess, [v; v]) in
 	     let r = (t, Rule(!nrule, PhaseChange, hyp, concl, [])) in
 	     add_rule hyp concl [] PhaseChange;
@@ -1501,11 +1692,12 @@ let transl p =
 	     r) (if !Param.ignore_types then [Param.any_type] else !Param.all_types)
 
   end;
-  
+
    List.iter (fun ch -> match ch.f_cat with
                           Name r -> r.prev_inputs <- Some (FunApp(ch, []))
                         | _ -> internal_error "should be a name 1")
-	(!Param.freenames);
+     (!Param.freenames);
+
    transl_process 
      { hypothesis = []; constra = []; unif = []; last_step_unif = [];
        success_conditions = None; name_params = []; 
@@ -1514,7 +1706,11 @@ let transl p =
        input_pred = Param.get_pred (InputP(0));
        output_pred = Param.get_pred (OutputP(0));
        hyp_tags = []; 
+       stronger_state = PhiIsStronger;
+       last_states = initial_cell_states ();
+       cell_locks = List.map (fun _ -> false) !Param.cells;
      } p;
+
    List.iter (fun ch -> match ch.f_cat with
                           Name r -> r.prev_inputs <- None
                         | _ -> internal_error "should be a name 2")
@@ -1555,7 +1751,11 @@ let transl p =
   List.iter (function (f,n) ->
     Selfun.add_no_unif f n) (if !Param.typed_frontend then Pitsyntax.get_nounif() else Pisyntax.get_nounif());
 
-  List.rev (!red_rules)
+  let preground_result = (List.rev (!red_rules)) in
+  (if (!Param.grounding) then
+      (Optimisation.grounding preground_result)
+    else
+      (preground_result))
 
 (* Move restrictions under inputs to make the analysis more precise *)
 
@@ -1628,5 +1828,7 @@ let rec move_new accu = function
       put_new l1 (Get(pat, t1, move_new l2 p, occ))
   | Phase(n,p,occ) ->
       Phase(n, move_new accu p,occ)
-      
+  | Lock(cell, p) -> Lock(cell, move_new accu p)
+  | Unlock(cell, p) -> Unlock(cell, move_new accu p)
+
 let move_new p = move_new [] p
diff --git a/src/reduction.ml b/src/reduction.ml
index 17b8bca..39750df 100644
--- a/src/reduction.ml
+++ b/src/reduction.ml
@@ -1141,11 +1141,11 @@ let rec init_rule state tree =
 		  begin
 		    let (p,c) = 
 		      match tree.thefact with
-			Pred(p,[t]) -> (p,rev_name_subst t)
+			Pred(p,args) -> let phi, [t] = Lists.head_tail args 1 in (p,rev_name_subst t)
 		      | _ -> Parsing_helper.internal_error "unexpected Apply clause"
 		    in
 		    let h = List.map (function 
-			{ thefact = Pred(_,[t]) } -> rev_name_subst t
+			{ thefact = Pred(_,args) } -> let phi, [t] = Lists.head_tail args 1 in rev_name_subst t
 		      |	_ -> Parsing_helper.internal_error "unexpected Apply clause") sons
 		    in
 	            {state1 with prepared_attacker_rule = (p, decompose_list h, decompose_term c)::state1.prepared_attacker_rule}
@@ -1153,7 +1153,8 @@ let rec init_rule state tree =
               | Rn _ ->
                   begin
 	            match tree.thefact with
-                      Pred(p, [t]) ->
+                      Pred(p, args) ->
+                        let (_, [t]) = (Lists.head_tail args 1) in
                         { state1 with prepared_attacker_rule = (p, [], [rev_name_subst t])::state1.prepared_attacker_rule }
                     | _ -> 
 			Parsing_helper.internal_error "Rule Rn should conclude p(name)"
@@ -2342,6 +2343,8 @@ let rec simplify_tree first recheck next_f tree =
 		FactHashtbl.add fact_hashtbl fact_id concl
 	    else
 	      check_coherent factId' (concl, l1, name_params, sons)
+	| AssignmentTag _ | ReadTag _ ->
+	    check_coherent factId' (concl, l1, name_params, sons)
 	| LetTag occ | TestTag occ | LetFilterTag occ | TestUnifTag2 occ ->
 	    check_coherent factId' (concl, l1, name_params, sons)
 	| InputTag _ | GetTag _ | BeginFact | LetFilterFact -> 
diff --git a/src/reduction_helper.ml b/src/reduction_helper.ml
index 0390562..b23a5d6 100644
--- a/src/reduction_helper.ml
+++ b/src/reduction_helper.ml
@@ -95,6 +95,13 @@ let rec occurs_var_proc v = function
       (occurs_var_pat v pat) || (Terms.occurs_var v t) || 
       (occurs_var_proc v p)
   | Phase(_,p,_) -> occurs_var_proc v p
+  | Lock(_,p) | Unlock(_,p) -> occurs_var_proc v p
+  | Assign(pairs, p) ->
+      (List.exists (Terms.occurs_var v) (snd (List.split pairs)))
+      || (occurs_var_proc v p)
+  | ReadAs(pairs, p) ->
+      (List.exists (occurs_var_pat v) (snd (List.split pairs)))
+      || (occurs_var_proc v p)
 
 (* Determine which variables should be included as arguments of names,
    so that queries can be answered *)
@@ -387,6 +394,10 @@ let rec process_subst p n1 n2 =
   | Get(pat, t, p, occ) -> Get(pat_subst pat n1 n2, term_subst t n1 n2, process_subst p n1 n2, occ)
   | Phase(n,p,occ) -> Phase(n,process_subst p n1 n2,occ)
   | LetFilter(bl, f, p, q, occ) -> LetFilter(bl, fact_subst f n1 n2, process_subst p n1 n2, process_subst q n1 n2, occ) 
+  | Lock(cell, p) -> Lock(cell, process_subst p n1 n2)
+  | Unlock(cell, p) -> Unlock(cell, process_subst p n1 n2)
+  | Assign(pairs, p) -> Assign((List.map (fun (cell, term) -> (cell, (term_subst term n1 n2))) pairs), process_subst p n1 n2)
+  | ReadAs(pairs, p) -> ReadAs((List.map (fun (cell, pattern) -> (cell, (pat_subst pattern n1 n2))) pairs), process_subst p n1 n2)
 
 (* let process_subst = Profile.f4 "process_subst" process_subst *)
 
@@ -419,6 +430,10 @@ let rec copy_process = function
   | Get(pat, t, p, occ) -> let pat' = copy_pat pat in Get(pat', copy_term2 t, copy_process p, occ)
   | Phase(n,p,occ) -> Phase(n, copy_process p,occ)
   | LetFilter(bl, f, p, q, occ) -> let bl' = List.map copy_binder bl in LetFilter(bl', copy_fact2 f, copy_process p, copy_process q, occ)
+  | Lock(cell, p) -> Lock(cell, copy_process p)
+  | Unlock(cell, p) -> Unlock(cell, copy_process p)
+  | Assign(pairs, p) -> Assign((List.map (fun (cell, term) -> (cell, (copy_term2 term))) pairs), (copy_process p))
+  | ReadAs(pairs, p) -> ReadAs((List.map (fun (cell, pattern) -> (cell, pattern)) pairs), (copy_process p))
 
 
 (* Close all terms after term_evaluation. Indeed, new variables may
diff --git a/src/rules.ml b/src/rules.ml
index 511676f..cd390ff 100644
--- a/src/rules.ml
+++ b/src/rules.ml
@@ -262,7 +262,7 @@ let occur_count_constra v l =
    inequalities.
  *)
 
-let elim_any_x ((hypl', concl, histl', constra) as r) =
+let elim_any_x ((hypl', concl, histl', constra)) =
    let (hypl'', _, histl'') = List.fold_right (fun hyp1 (hypl, nl, histl) ->
      match hyp1 with
        Pred(chann, l) ->
@@ -697,7 +697,7 @@ let reorder hyp =
 
 (* 5. The final function for subsumption test *)
 
-let implies ((hyp1, concl1, _, constr1) as r1) ((hyp2, concl2, _, constr2) as r2) =
+let implies ((hyp1, concl1, _, constr1)) ((hyp2, concl2, _, constr2)) =
   if List.length hyp1 > List.length hyp2 then false else
   (* let t0 = Unix.times() in *)
    try 
diff --git a/src/types.mli b/src/types.mli
index 25c13ff..a153418 100644
--- a/src/types.mli
+++ b/src/types.mli
@@ -104,6 +104,10 @@ and process =
   | Insert of term * process * occurrence
   | Get of pattern * term * process * occurrence
   | Phase of int * process * occurrence
+  | Lock of string list * process
+  | Unlock of string list * process
+  | ReadAs of (string * pattern) list * process
+  | Assign of (string * term) list * process
 
 and linktype = 
     NoLink
@@ -191,6 +195,8 @@ type hypspec =
   | OutputPTag of occurrence
   | InsertTag of occurrence
   | GetTag of occurrence
+  | AssignmentTag of int list (* cell indices *)
+  | ReadTag of int list (* cell indices *)
 
 type label =
     ProcessRule of hypspec list * term list 
